<?php

namespace App\Console\Commands;

use App\Helpers\Helper;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Mail;
use Exception;

class AuditReminderMailCron extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'app:audit-reminder-mail-cron';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Sending reminder mails everyday in morning to concern person as per the status of audit status';

    /**
     * Execute the console command.
     */
    public function handle(): void
    {
        //\Log::info("Cron is working fine!");
        /* Write your database logic here */
        $audit_data = array();
        $sSQL = 'SELECT id,user_party,audit_status,audit_start_date,raise_concern_end_date,concern_review_end_date,cap_plan_end_date,cap_accepted_end_date,cap_process_end_date,cap_review_end_date,`program_id`,(SELECT program_name FROM master_programes WHERE id=program_id) program_name,`country_id`,`state_id`,(SELECT name FROM `master_states` WHERE id=state_id) state_name,`district_id`,(SELECT name FROM `master_districts` WHERE id=district_id) district_name,`brand_id`,(SELECT brand_name FROM `master_brands` WHERE id=brand_id) brand_name FROM `cc_audit` WHERE `audit_status` !=:auditInProgress AND `audit_status` !=:capReview';
        $audit_data = DB::select($sSQL,array(
            'auditInProgress' => config('custom.audit_in_progress'),
            'capReview' => config('custom.cap_review'),
        ));
        //India-Maharashtra-Nanded-Reel-Mark
        foreach($audit_data as $single_audit){
            $data['excelUrlPath'] = '';
            $excelUrlPath = Helper::generate_excel($single_audit->id);
            if($excelUrlPath['error'] == 0){
                $data['excelUrlPath'] = $excelUrlPath['data'];
            }
            // dd($data['excelUrlPath']);
            // Log::info($data['excelUrlPath']);

            $single_audit->remaining_days = 0;
            if($single_audit->audit_status == 2){
                $single_audit->audit_status_name = config('custom.concern_in_progress_status');
                if(!empty($single_audit->raise_concern_end_date) && !empty($single_audit->audit_start_date)){
                    $diff = strtotime($single_audit->raise_concern_end_date) - strtotime("now");
                    // 1 day = 24 hours
                    // 24 * 60 * 60 = 86400 seconds
                    $single_audit->remaining_days = (int)ceil($diff / 86400);
                }

                if($single_audit->user_party == 3){
                    //Get Mel Concern person
                    //$team_id = '4';
                    $team_id = config('custom.mel_team');
                }else{
                    //Get Farm and SC Team Concern person
                    // $team_id = '2,3';
                    $team_id = config('custom.farm_team').','.config('custom.sc_team');
                }
            }

            if($single_audit->audit_status == 3){
                $single_audit->audit_status_name = config('custom.review_concern_status');
                if(!empty($single_audit->concern_review_end_date)){
                    $diff = strtotime($single_audit->concern_review_end_date) - strtotime("now");
                    $single_audit->remaining_days = (int)ceil($diff / 86400);
                }

                if($single_audit->user_party == 3){
                    //Get Third Party Concern person
                    //$team_id = '8';
                    $team_id = config('custom.third_party_team');
                }else{
                    //Get MEL Team Concern person
                    //$team_id = '4';
                    $team_id = config('custom.mel_team');
                }
            }

            if($single_audit->audit_status == 4){
                $single_audit->audit_status_name = config('custom.final_progress_status');
                if(!empty($single_audit->cap_plan_end_date)){
                    $diff = strtotime($single_audit->cap_plan_end_date) - strtotime("now");
                    $single_audit->remaining_days = (int)ceil($diff / 86400);
                }

                //Get Local/Ginning Team Concern person
                //$team_id = '6,7';
                $team_id = config('custom.local_team').','.config('custom.ginning_team');
            }

            if($single_audit->audit_status == 5){
                $single_audit->audit_status_name = config('custom.cap_plan_progress_status');
                if(!empty($single_audit->cap_accepted_end_date)){
                    $diff = strtotime($single_audit->cap_accepted_end_date) - strtotime("now");
                    $single_audit->remaining_days = (int)ceil($diff / 86400);
                }

                //Get Farm/SC Team Concern person
                //$team_id = '2,3';
                $team_id = config('custom.farm_team').','.config('custom.sc_team');
            }

            if($single_audit->audit_status == 6){
                $single_audit->audit_status_name = config('custom.cap_plan_accept_status');
                if(!empty($single_audit->cap_process_end_date)){
                    $diff = strtotime($single_audit->cap_process_end_date) - strtotime("now");
                    $single_audit->remaining_days = (int)ceil($diff / 86400);
                }

                //Get Local/Ginning Team Concern person
                //$team_id = '6,7';
                $team_id = config('custom.local_team').','.config('custom.ginning_team');
            }

            if($single_audit->audit_status == 7){
                $single_audit->audit_status_name = config('custom.cap_action_progress_status');
                if(!empty($single_audit->cap_review_end_date)){
                    $diff = strtotime($single_audit->cap_review_end_date) - strtotime("now");
                    $single_audit->remaining_days = (int)ceil($diff / 86400);
                }

                //Get MEL Team Concern person
                //$team_id = '4';
                $team_id = config('custom.mel_team');
            }

            $single_audit->mail_ids = array();
            $single_audit->subject_line = '';
              
            $sUSERLIST = 'SELECT `user_id`,u.`username` FROM `user_country_state_dist_prog_brand` ucsdpb JOIN `users` u ON ucsdpb.user_id = u.id WHERE ucsdpb.`country_id` ='.$single_audit->country_id.' AND (ucsdpb.`state_id` ='.$single_audit->state_id.' OR ucsdpb.`state_id` = 0) AND (ucsdpb.`district_id` ='.$single_audit->district_id.' OR ucsdpb.`district_id` = 0) AND (ucsdpb.`program_id` ='.$single_audit->program_id.' OR ucsdpb.`program_id` = 0) AND (ucsdpb.`brand_id` = '.$single_audit->brand_id.' OR ucsdpb.`brand_id` = 0) AND u.team_id IN ('.$team_id.')';
            $ausers = DB::select($sUSERLIST, array());
            foreach($ausers as $user){
                $single_audit->mail_ids[] = $user->username;
            }

            if($single_audit->user_party == 3){
                $single_audit->subject_line = 'Please submit '. $single_audit->state_name.' '.$single_audit->program_name.' '.$single_audit->brand_name;
            }else{
                $single_audit->subject_line = 'Please submit '. $single_audit->state_name.' '.$single_audit->district_name.' '.$single_audit->program_name.' '.$single_audit->brand_name;
            }

            if($single_audit->remaining_days > 0){
                $single_audit->subject_line .= ' audit report in the '.$single_audit->remaining_days.' day that remaining';
            }else{
                $single_audit->subject_line .= ' audit report that already '.abs($single_audit->remaining_days).' days overdue';
            }

            $data['state_name'] = $single_audit->state_name;
            $data['district_name'] = ($single_audit->district_name)?$single_audit->district_name:'-';
            $data['program_name'] = $single_audit->program_name;
            $data['brand_name'] = $single_audit->brand_name;

            $data['remaining_days'] = $single_audit->remaining_days;
            $data['audit_status'] = $single_audit->audit_status_name;

            // $mail_from = env('MAILFROM','prime@swtprime.com');
            // $mail_name = env('MAILNAME','SWT-Prime');
            // $mail_from = env('MAILFROM','noreply@cottonconnectautomate.com');
            // $mail_name = env('MAILNAME','CottonConnect');

            $mail_from = config('custom.mail_from');
            $mail_name = config('custom.mail_name');

            $mail_ids = $single_audit->mail_ids;
            $subject_line = $single_audit->subject_line;
           //dump($mail_ids);dump($subject_line);dump($mail_from); dd($mail_name);
            try{
                Mail::send('send_reminder_mail', $data, function($message) use ($mail_ids,$subject_line,$mail_from,$mail_name) {
                    $message->to($mail_ids)->subject($subject_line);
                    //$message->attach('C:\laravel-master\laravel\public\uploads\image.png');
                    //$message->attach('C:\laravel-master\laravel\public\uploads\test.txt');
                    $message->from($mail_from,$mail_name);
                });
                //return true;
                \Log::info("Mail Send Successfully");
            }
            catch(Exception $e){
                $message = $e->getMessage();
                // var_dump('Exception Message: '. $message);
    
                // $code = $e->getCode();       
                // var_dump('Exception Code: '. $code);
    
                // $string = $e->__toString();       
                // var_dump('Exception String: '. $string);
    
                //exit;
                //return false;
                Log::error('Exception Message: '. $message);
            }
        }
        //dd($audit_data);
    }


    // public function handle(): void
    // {
    //     //\Log::info("Cron is working fine!");
     
    //     /* Write your database logic here */
    //     $audit_data = array();
    //     $sSQL = 'SELECT id,user_party,audit_status,audit_start_date,raise_concern_end_date,concern_review_end_date,cap_plan_end_date,cap_accepted_end_date,cap_process_end_date,cap_review_end_date,`program_id`,(SELECT program_name FROM master_programes WHERE id=program_id) program_name,`state_id`,(SELECT name FROM `master_states` WHERE id=state_id) state_name,`district_id`,(SELECT name FROM `master_districts` WHERE id=district_id) district_name,`brand_id`,(SELECT brand_name FROM `master_brands` WHERE id=brand_id) brand_name FROM `cc_audit` WHERE `audit_status` !=:auditInProgress AND `audit_status` !=:capReview';
    //     $audit_data = DB::select($sSQL,array(
    //         'auditInProgress' => config('custom.audit_in_progress'),
    //         'capReview' => config('custom.cap_review'),
    //     ));

    //     foreach($audit_data as $single_audit){
    //         $data['excelUrlPath'] = '';
    //         $excelUrlPath = Helper::generate_excel($single_audit->id);
    //         if($excelUrlPath['error'] == 0){
    //             $data['excelUrlPath'] = $excelUrlPath['data'];
    //         }
    //         // dd($data['excelUrlPath']);
    //         // Log::info($data['excelUrlPath']);

    //         $single_audit->remaining_days = 0;
    //         if($single_audit->audit_status == 2){
    //             $single_audit->audit_status_name = config('custom.concern_in_progress_status');
    //             if(!empty($single_audit->raise_concern_end_date) && !empty($single_audit->audit_start_date)){
    //                 $diff = strtotime($single_audit->raise_concern_end_date) - strtotime("now");
    //                 // 1 day = 24 hours
    //                 // 24 * 60 * 60 = 86400 seconds
    //                 $single_audit->remaining_days = (int)ceil($diff / 86400);
    //             }

    //             if($single_audit->user_party == 3){
    //                 //Get Mel Concern person
    //                 //$team_id = '4';
    //                 $team_id = config('custom.mel_team');
    //             }else{
    //                 //Get Farm and SC Team Concern person
    //                 // $team_id = '2,3';
    //                 $team_id = config('custom.farm_team').','.config('custom.sc_team');
    //             }
    //         }

    //         if($single_audit->audit_status == 3){
    //             $single_audit->audit_status_name = config('custom.review_concern_status');
    //             if(!empty($single_audit->concern_review_end_date)){
    //                 $diff = strtotime($single_audit->concern_review_end_date) - strtotime("now");
    //                 $single_audit->remaining_days = (int)ceil($diff / 86400);
    //             }

    //             if($single_audit->user_party == 3){
    //                 //Get Third Party Concern person
    //                 //$team_id = '8';
    //                 $team_id = config('custom.third_party_team');
    //             }else{
    //                 //Get MEL Team Concern person
    //                 //$team_id = '4';
    //                 $team_id = config('custom.mel_team');
    //             }
    //         }

    //         if($single_audit->audit_status == 4){
    //             $single_audit->audit_status_name = config('custom.final_progress_status');
    //             if(!empty($single_audit->cap_plan_end_date)){
    //                 $diff = strtotime($single_audit->cap_plan_end_date) - strtotime("now");
    //                 $single_audit->remaining_days = (int)ceil($diff / 86400);
    //             }

    //             //Get Local/Ginning Team Concern person
    //             //$team_id = '6,7';
    //             $team_id = config('custom.local_team').','.config('custom.ginning_team');
    //         }

    //         if($single_audit->audit_status == 5){
    //             $single_audit->audit_status_name = config('custom.cap_plan_progress_status');
    //             if(!empty($single_audit->cap_accepted_end_date)){
    //                 $diff = strtotime($single_audit->cap_accepted_end_date) - strtotime("now");
    //                 $single_audit->remaining_days = (int)ceil($diff / 86400);
    //             }

    //             //Get Farm/SC Team Concern person
    //             //$team_id = '2,3';
    //             $team_id = config('custom.farm_team').','.config('custom.sc_team');
    //         }

    //         if($single_audit->audit_status == 6){
    //             $single_audit->audit_status_name = config('custom.cap_plan_accept_status');
    //             if(!empty($single_audit->cap_process_end_date)){
    //                 $diff = strtotime($single_audit->cap_process_end_date) - strtotime("now");
    //                 $single_audit->remaining_days = (int)ceil($diff / 86400);
    //             }

    //             //Get Local/Ginning Team Concern person
    //             //$team_id = '6,7';
    //             $team_id = config('custom.local_team').','.config('custom.ginning_team');
    //         }

    //         if($single_audit->audit_status == 7){
    //             $single_audit->audit_status_name = config('custom.cap_action_progress_status');
    //             if(!empty($single_audit->cap_review_end_date)){
    //                 $diff = strtotime($single_audit->cap_review_end_date) - strtotime("now");
    //                 $single_audit->remaining_days = (int)ceil($diff / 86400);
    //             }

    //              //Get MEL Team Concern person
    //              //$team_id = '4';
    //              $team_id = config('custom.mel_team');
    //         }

    //         $single_audit->mail_ids = array();
    //         $single_audit->subject_line = '';
    //         if($single_audit->user_party == 3){
    //             $sUSERLIST = 'SELECT `user_id` FROM `user_program_brand_state` upbs JOIN `users` u ON upbs.user_id = u.id JOIN master_user_roles mur ON u.user_role = mur.id WHERE `program_id` ='.$single_audit->program_id.' AND `brand_id` = '.$single_audit->brand_id.' AND `state_id` ='.$single_audit->state_id.' AND mur.team_id IN ('.$team_id.')';
    //             $ausers = DB::select($sUSERLIST, array());

    //             $single_audit->subject_line = 'Please submit '. $single_audit->state_name.' '.$single_audit->program_name.' '.$single_audit->brand_name;

    //         }else{
    //             $sUSERLIST = 'SELECT u.id,u.`username` FROM `user_program_brand` upb JOIN `users` u ON upb.user_id = u.id JOIN master_user_roles mur ON u.user_role = mur.id WHERE `program_id` ='.$single_audit->program_id.' AND `brand_id` = '.$single_audit->brand_id.' AND `district_id` ='.$single_audit->district_id.' AND mur.team_id IN ('.$team_id.')';

    //             $ausers = DB::select($sUSERLIST, array());
    //             foreach($ausers as $user){
    //                 $single_audit->mail_ids[] = $user->username;
    //             }

    //             $single_audit->subject_line = 'Please submit '. $single_audit->state_name.' '.$single_audit->district_name.' '.$single_audit->program_name.' '.$single_audit->brand_name;
    //         }

    //         if($single_audit->remaining_days > 0){
    //             $single_audit->subject_line .= ' audit report in the '.$single_audit->remaining_days.' day that remaining';
    //         }else{
    //             $single_audit->subject_line .= ' audit report that already '.abs($single_audit->remaining_days).' days overdue';
    //         }

    //         $data['state_name'] = $single_audit->state_name;
    //         $data['district_name'] = ($single_audit->district_name)?$single_audit->district_name:'-';
    //         $data['program_name'] = $single_audit->program_name;
    //         $data['brand_name'] = $single_audit->brand_name;

    //         $data['remaining_days'] = $single_audit->remaining_days;
    //         $data['audit_status'] = $single_audit->audit_status_name;

    //         // $mail_from = env('MAILFROM','prime@swtprime.com');
    //         // $mail_name = env('MAILNAME','SWT-Prime');
    //         // $mail_from = env('MAILFROM','noreply@cottonconnectautomate.com');
    //         // $mail_name = env('MAILNAME','CottonConnect');

    //         $mail_from = config('custom.mail_from');
    //         $mail_name = config('custom.mail_name');

    //         $mail_ids = $single_audit->mail_ids;
    //         $subject_line = $single_audit->subject_line;
    //        //dump($mail_ids);dump($subject_line);dump($mail_from); dd($mail_name);
    //         try{
    //             Mail::send('send_reminder_mail', $data, function($message) use ($mail_ids,$subject_line,$mail_from,$mail_name) {
    //                 $message->to($mail_ids)->subject($subject_line);
    //                 //$message->attach('C:\laravel-master\laravel\public\uploads\image.png');
    //                 //$message->attach('C:\laravel-master\laravel\public\uploads\test.txt');
    //                 $message->from($mail_from,$mail_name);
    //             });
    //             //return true;
    //             \Log::info("Mail Send Successfully");
    //         }
    //         catch(Exception $e){
    //             $message = $e->getMessage();
    //             // var_dump('Exception Message: '. $message);
    
    //             // $code = $e->getCode();       
    //             // var_dump('Exception Code: '. $code);
    
    //             // $string = $e->__toString();       
    //             // var_dump('Exception String: '. $string);
    
    //             //exit;
    //             //return false;
    //             Log::error('Exception Message: '. $message);
    //         }
    //     }
    //     //dd($audit_data);
    // }
}
